/*
    Pezzonoid - An implementation of the classic Arkanoid using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Fabio Pezzo

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ARKANOID_H
#define ARKANOID_H

#include "Allegro.h"
#include "ball.h"
#include "brick.h"
#include "bar.h"

class Arkanoid : public Allegro
{
  private:
  int ticks;    
  bool gameOver;


  int level;
  Text levelText;

  int score;
  Text scoreText;

  int lifes;
  Text lifesText;
  
  int remainingBricks;

  CompositeSprite backgroundLayer;
  CompositeSprite middleLayer;
  CompositeSprite brickLayer;
 

  SampleSound backgroundSound;
  SampleSound brickSound;
  SampleSound barSound;
  SampleSound loseSound;
  SampleSound victorySound;
  Bar bar;
  Ball ball;
  Brick brick;


  public:
  Arkanoid();
  bool isGameOver() const { return gameOver; }
  virtual ~Arkanoid();
  virtual void onTick();

};



#endif
