/*
    Pezzonoid - An implementation of the classic Arkanoid using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Fabio Pezzo

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "brick.h"

Brick::Brick() : Sprite ("brickG.bmp",Point(x,y)), x(1),y(70), life(1)
{}

Brick::~Brick()
{}



bool Brick::hitUpperSide(int ballX, int ballY)
{
  int startBrick = getLeftTopCorner().getX();
  int endBrick = getLeftTopCorner().getX() + getWidth();
  int upperBaseY = getLeftTopCorner().getY();

  if ( startBrick <= ballX && ballX <= endBrick && upperBaseY <= ballY+13 && ballY+13 <= upperBaseY+5) //se il mattoncino è colpito
  {
    life = 0;
    return true;
  }
    else
  return false;
}


bool Brick::hitBase(int ballX, int ballY)
{
  int startBrick = getLeftTopCorner().getX();
  int endBrick = getLeftTopCorner().getX() + getWidth();
  int baseY = getLeftTopCorner().getY() + getHeight();

  if ( startBrick <= ballX && ballX <= endBrick && baseY == ballY ) //se il mattoncino è colpito
  {
    life = 0;
    return true;
  }
    else
  return false;
}


bool Brick::hitRightSide(int ballX, int ballY)
{
  int upperBase = getLeftTopCorner().getY(); 
  int baseY = getLeftTopCorner().getY() + getHeight();
  int rightX = getLeftTopCorner().getX() + getWidth(); //topcorner + larghezza

  if ( upperBase <= ballY && ballY <= baseY && rightX-5 <= ballX  && ballX <= rightX) //se il mattoncino è colpito
  {
    life = 0;
    return true;
  }
    else
 return false;
}



bool Brick::hitLeftSide(int ballX, int ballY)
{
  int upperBase = getLeftTopCorner().getY(); 
  int baseY = getLeftTopCorner().getY() + getHeight();
  int leftX = getLeftTopCorner().getX();

  if ( upperBase <= ballY && ballY <= baseY && leftX <= ballX+12 && ballX+12 <= leftX+5 ) //se il mattoncino è colpito
  {
    life = 0;
    return true;
  }
  else
  return false;
}




